import serial,time
#Global Variables
fpga = None;
timeOutOnSolve = False;
timeOutTime = 10;
stepSize = 1000000
maxPassword = 100000000
#dictionary to convert string to binary
hexValues = {
                "0" : 0,
                "1" : 1,
                "2" : 2,
                "3" : 3,
                "4" : 4,
                "5" : 5,
                "6" : 6,
                "7" : 7,
                "8" : 8,
                "9" : 9,
                "A" : 10,
                "B" : 11,
                "C" : 12,
                "D" : 13,
                "E" : 14,
                "F" : 15,
            }

testHashes =    [
                    #["Hash","Password","Returned Value","Clock Cycles","Running Time"]
                    #["so","8b68c4f13ab86e9b2309c790d525c6d6","",0,0,0],
                    ["axe","c89ee4a2c9dcae6581ca53bff9aa4ee5","",0,0,0],
                    ["wax","6f96cbe1e77384f429dfce5f6072b105","",0,0,0],
                    #["test","098f6bcd4621d373cade4e832627b4f6","",0,0,0],
                    #["<<<<","83699a49d8884e65d9291885a6448e44","",0,0,0],
                    ["vader","2db1850a4fe292bd2706ffd78dbe44b9","",0,0,0],
                    #["chewie","964d72e72d053d501f2949969849b96c","",0,0],
                    #["Newton","1c8b97c83b0726216cd5dbc88a64b0ed","",0,0],
                    #["padawan","9a4b83013501fde3e8864f4f4b5fb7c5","",0,0],
                    #["deadstar","25c6bcb1a6be89e1585f7d494c49aef5","",0,0],
                    #["tes}","fcd0d5621e60e2a0542f5f34f08c907c","",0,0],
                    #["}","cbb184dd8e05c9709e5dcaedaa0495cf","",0,0],
                    #["AA~","af3dd8d5f40867e31864297e938e9740","",0,0],
                    #["A~","1bb6a03994b24bf5a99d9445176a8f76","",0,0],
                ]

#Main Method
def main():  
    FPGAinit('COM5',0.5)
    flush()
    #generateHashesToTest()

    for i in range(len(testHashes)):
        start_time = time.time()
        password, count = solvePassword(testHashes[i][1]);
        testHashes[i][2] = password;
        testHashes[i][3] = count;
        testHashes[i][4] = (time.time() - start_time);
        print("solved")
        password = "";
        for j in range(len(testHashes[i][2])):
            password = password + testHashes[i][2][j].decode("utf-8"); 
        oneLine = testHashes[i][0] + "\t" + testHashes[i][1] + "\t" + password + "\t" + str(testHashes[i][3])+ "\t" + str(testHashes[i][4]) + "\t" + str(testHashes[i][5]) ; 
        print(oneLine);
    writeToFile("Test.txt");
    print("Complete")
    
    #print("Password of hash: ",convertByteArrayToString(password), " took: " ,count, "clock cycles")


#Methods to determine values
def generateHashesToTest():
    import hashlib
    password = " ";
    step = stepSize;
    for i in range(1,maxPassword,step):
        m = hashlib.md5()
        m.update(password.encode('utf-8'))
        MD5Hash = m.hexdigest()
        #if(password.find("~") == -1):
        testHashes.append([password,MD5Hash,"",0,0,i])
        for j in range(step):
            password = incrementString(password);

def incrementString(password):
    length = len(password);
    carry = 1;
    password = list(password)
    for i in range(length-1,-1,-1):
        if(carry == 1):
            charInt = ord(password[i]);
            if(charInt == 126):
                charInt = 32
                carry = 1
            else:
                charInt +=1
                carry = 0
            password[i] = chr(charInt);

    password = "".join(password)        
    if(carry == 1):
        password = " " + password
    return password

def writeToFile(filename):
    file = open(filename,"w");
    #file.write("Password\tHash\t\t\t\tReturned Value\tClock Cycles\tRun Time\tPassword Index\n")
    for i in range(len(testHashes)):
        password = "";
        for j in range(len(testHashes[i][2])):
            password = password + testHashes[i][2][j].decode("utf-8"); 
        #oneLine = testHashes[i][0] + "\t" + testHashes[i][1] + "\t" + password + "\t" + str(testHashes[i][3])+ "\t" + str(testHashes[i][4])+ "\t" + str(testHashes[i][5]) + "\n" 
        #print(oneLine);
        oneLine = str(testHashes[i][3])+ "\t" + str(testHashes[i][4])+ "\t" + str(testHashes[i][5]) + "\n";
        file.write(oneLine);
    file.close();

def solvePassword(hashString):
    print("Solving Password: ",hashString)
    hashByteArray = convertStringtoByteArray(hashString)
    flush()
    sendHash(hashByteArray)
    checks = 0;
    start_time = time.time()
    while True:
        #checks = checks + 1;
        #if(checkSolvedFlag):
            #solved,password = getPassword();
            #if(solved == True):
             #   return password,getCount();
        #if(checks == 40):
        solved,password = getPassword();
        #checks = 0;
        if(solved == True):
             return password,0;
        if(timeOutOnSolve):
            if(time.time() - start_time > timeOutTime):
                return [b"\x00",b"\x00",b"\x00",b"\x00",b"\x00",b"\x00",b"\x00",b"\x00"], -1;

def convertByteArrayToString(byteArray):
    string = ''
    for i in range(len(byteArray)):
        if(byteArray[i] != b'\x00'):           
            char = byteArray[i].decode()
            string = string + char
    return string
    
def convertStringtoByteArray(string):
    string = string.upper()
    array = []
    for i in range(0,len(string),2):
        number = (hexValues[string[i]] <<4) + hexValues[string[i+1]]
        array.append((number).to_bytes(1, byteorder='big'));
    return array

#FPGA operating functions
    
#INitialisation Function
def FPGAinit(com,timeoutValue):
    print("Initialising connection")
    global fpga
    fpga = serial.Serial(com, 100000,bytesize=serial.EIGHTBITS,timeout = timeoutValue);
    print("Initialising complete com = ",com, ". Timeout = ",timeoutValue,".")

#Sends the hash value to the FPGA
def sendHash(hashValue):
    if(len(hashValue)!=16):
        print("Incorrect length hash")
        return False
    #print("Sending Hash: ", hashValue)

    fpga.write(b"\x01");
    for i in range(0,16):
        fpga.write(hashValue[i]);
        #print("Sent:" ,hashValue[i])
    time.sleep(0.1);
    flush()
    #print("Sending Hash Complete, Checking for correctness")
    if(getHash() == hashValue):
        print("Hash Value Sent")
        return True;
    else:
        sendHash(hashValue)

#Gets the count value from the FPGA
def getCount():
    flush();
    #print("Sending Code 0b00000010")
    fpga.write(b"\x02");
    #print("Waiting for FPGA data")
    r = fpga.read()
    #print("Received Code: ",r)
    x = 0;
    for i in range (0,16):
        r = fpga.read()
        numIn = int.from_bytes(r, byteorder='big')
        x = x<<8
        x = x + numIn
        #print(i)
        #print("Bit: ",i," Byte equals: ",r," This equals: ", numIn, " Total Value: ",x)
    #print("integer value: ",x, " clock cycles")
    return x;


#Determines if the FPGA has solved its stuff
def checkSolvedFlag():
    #print("Checking if the FPGA has indicated the hash has been solved")
    if(fpga.read() == b"\x09"):
        return True
    return False

#gets the hash that was sent to the FPGA
def getHash():
    flush()
    #print("Getting the MD5 hash stored in the FPGA")
    fpga.write(b"\x0A");
    r = fpga.read()
    #print("Received Code: ",r)
    if(r == b"\x0A"):
        #print("Receiving Hash")
        byteArray = []
        for i in range (0,16):
            r = fpga.read()
            byteArray.append(r);
    else: byteArray = []
    return byteArray;

#Get the password that was calculated by the FPGA
def getPassword():
    #print("Getting the password from the FPGA")
    #print("Sending Code 0b00001000")
    fpga.write(b"\x08");
    #print("Waiting for FPGA data")
    r = fpga.read()
    #print("Received Code: ",r)
    if(r == b"\x06"):
        #print("Password Found")
        array = []
        for i in range (0,10):
            r = fpga.read()
            #print(r)
            #print("Bit: ",i," Byte equals: ",r," This equals: ", numIn, " Total Value: ",x)
            array.append(r);
        #print("Password Received")
        return True, array;
    elif(r == b"\x07"):
        #print("Password Not Yet Found")
        return False, []
    else:
        return False, []

#Flush the pipeline containing all the read data
def flush():
    #print("Flushing the buffer")
    fpga.flushInput();

main();
