module VADER(
	input 		Clk_100M,
	input 		UARTIn,
	input 		SendSwitch,
	input	 [3:0]Switches,
	output 		UARTOut,
	output [7:0]LEDs,
	output [7:0]LEDsDebug
);

//reg [127:0]	Count; //Random Count
reg [79:0]	PasswordTemp = 80'b00000000_00000000_00000000_00000000_00000000_01000001_01000010_01000011_01001010_01001011;

//Calculations get performed

/*always @(posedge Clk_100M) begin
	Count <= Count + 1'b1;
end*/


//UART Send or Tx or whatever its called
wire			UART_Send_Flag;
wire 			UART_Sent_Confirmation_Flag;
wire [7:0]	UART_Transmit_Byte;
UARTTx UARTSender (UART_Transmit_Byte,UART_Send_Flag,Clk_100M,UARTOut,UART_Sent_Confirmation_Flag);

//UART Receive or Rx or whatever
wire [7:0]	UART_Received_Byte;
wire			UART_Received_Byte_Ready;
wire			UART_Received_Byte_Acknowledge;
UARTRx UARTReceiver(Clk_100M,UARTIn,UART_Received_Byte_Acknowledge,UART_Received_Byte_Ready,UART_Received_Byte);

//Controller module
wire [127:0]MD5HashFromController;
wire			MD5HashReadyFlag;
wire 			Password_Ready_Flag;
wire 			SolvedDone;
wire [127:0]NumAttempts;
wire [63:0]	SolvedWord;


Controller controller(	Clk_100M,
								MD5HashFromController,MD5HashReadyFlag,NumAttempts,SolvedWord,SolvedDone,
								UART_Transmit_Byte,UART_Send_Flag,UART_Sent_Confirmation_Flag,
								UART_Received_Byte_Ready,UART_Received_Byte_Acknowledge,UART_Received_Byte
							);
								

//solver 

solvemanager solver(		Clk_100M,
								!MD5HashReadyFlag,
								MD5HashFromController,
								
								SolvedDone,
								SolvedWord,
								NumAttempts
						 );



//Pin assignments

assign Password_Ready_Flag = SendSwitch; /*& MD5_Hash_Ready_Flag*/;
assign LEDs[7:0] 		= MD5HashFromController[7:0];
assign LEDsDebug[7]	= MD5HashReadyFlag;
assign LEDsDebug[6:0]= MD5HashFromController[14:8];


endmodule
